/* 
        MaslAudio.cc

        MASL/M-MASL Copyright (c) KUNI/TDU
        Windows version Copyright (c) 1995, 1996 Tomoatsu Shimada  (shimarin)
        X Window System version Copyright (c)1997 Yamahata Isaku (ISA-9)
*/

#include <signal.h>
#include <string.h>

#include "MaslAudio.h"
#include "audio.h"

char* MaslAudio::isAudioWriting=NULL;//write٤PCM dataͭ뤫
//(ʤBoolͤ8ޤǤʤ餽줾bitɽ)
/* *isAudioWriting!=0 */
char* MaslAudio::isAudioWaiting=NULL;//PCMκλԤ򤷤Ƥ뤫
/* *isAudioWaiting!=0λԤ򤷤Ƥ롣*/
SAMPLE_DATA MaslAudio::sampleData;//PCMdata
SAMPLE_DATA MaslAudio::oldSampleData;//PCMdataκǽФƤ
  //sampleData.size=-1λƤʤ
//long MaslAudio::sampleRate;//PCMκrate
SAMPLE_DATA MaslAudio::queSampleData;//PCMdataκǽФƤ
  //queSampleData.data=NULL,queSampleData.size=-1λԤäƤdata̵
int MaslAudio::queChannel=-1;
//long MaslAudio::sampleRate;//PCMκrate

int MaslAudio::fragmentSize;//audio bufferfragment size
timeval MaslAudio::intervalOfWritingAudioData;//PCM񤭹ߤλֳִ

unsigned char* MaslAudio::nullSound=NULL;//̵data

#ifdef NO_SIGACTION
//⤷ʤ
#else
struct sigaction MaslAudio::sigAction;//signal handler
#endif


//sample rateѹ餳methodoɬƤӽФ
//classȤ٤򤹤
void MaslAudio::prepareMaslAudio (char* const mmsIsAudioWriting,
				  char* const mmsIsAudioWaiting)
{
  isAudioWriting=mmsIsAudioWriting;
  isAudioWaiting=mmsIsAudioWaiting;
  resetAudioVariable ();
  resetQueData ();
  //(ɬפʤfragmentsizeꤷ)

  //fragmentosizeƲ֤write()٤롣
  //(sampling rateɬ)
  fragmentSize=Audio::getFragmentSize ();
  int sampleRate=Audio::getSampleRate ();
  assert (sampleRate>0);
  intervalOfWritingAudioData.tv_sec=(long)fragmentSize/(long)sampleRate;
  intervalOfWritingAudioData.tv_usec=
    ((fragmentSize-intervalOfWritingAudioData.tv_sec*sampleRate)
     *((1000000L/sampleRate-1)));

/*
  intervalOfWritingAudioData.tv_usec=
    ((fragmentSize-intervalOfWritingAudioData.tv_sec*sampleRate)*1000000L)
    /sampleRate;
*/
/*
#ifdef DEBUG
  cerr << "fragmentSize=" << fragmentSize << endl;
  cerr << "tv_sec=" << intervalOfWritingAudioData.tv_sec << endl;
  cerr << "tv_usec=" <<   intervalOfWritingAudioData.tv_usec << endl;
#endif //DEBUG
*/

  //////signaoϢν
#ifdef NO_SIGACTION
  //⤷ʤ
#else
  sigAction.sa_handler=writeAudioData;
# ifdef linux
  sigAction.sa_flags=SA_RESTART;//this is NOT portable
# endif
#endif

#ifdef OPEN_SOUND_SYSTEM
  //nullSound̵֤ꤹ롣
  delete[] nullSound;
  nullSound=new unsigned char[fragmentSize];
  memset (nullSound,0x80,fragmentSize);
  //unsigned linear 8bit pcm̵֤0x80
#endif//OPEN_SOUND_SYSTEM
}

void MaslAudio::playAudio(const SAMPLE_DATA pcmData,
			 const int channel=-1)
{//channel=-1λϤɤchannelǺ뤫ꡣ
  ///////////////////////////괺ʤΤchannelϾʤ
  offAudioTimer ();
#ifdef RESET_AUDIO
  stopAudio (0xff);
#endif //RESET_AUDIO
  oldSampleData.data=sampleData.data=pcmData.data;
  oldSampleData.size=sampleData.size=pcmData.size;
  oldSampleData.isLoop=sampleData.isLoop=pcmData.isLoop;

#ifdef RESET_AUDIO
  writeAudioData (SIGALRM);
  writeAudioData (SIGALRM);
  //writeAudioData (SIGALRM);
  //2ԤȲڤͭߤʤ顢
  //3ԤȤƤ

  //ޤwrite٤dataĤäƤʤߤǺ³
  if (sampleData.data!=NULL)
    {
      *isAudioWriting=0xff;
      setAudioTimerOn();
    }
#else
  if (*isAudioWriting==0)
    {
      writeAudioData (SIGALRM);
      writeAudioData (SIGALRM);
      //writeAudioData (SIGALRM);
      //2ԤȲڤͭߤʤ顢
      //3ԤȤƤ

      //ޤwrite٤dataĤäƤʤߤǺ³
      if (sampleData.data!=NULL)
	{
	  *isAudioWriting=0xff;
	  setAudioTimerOn();
	}
    }
#endif//RESET_AUDIO
}


//ˤPCMκϤޤ롣
void MaslAudio::setAudioTimerOn()
{
  //ä֤(prepareMaslAudio()Ƿ)audio(write)
  //methodƤӽФ褦signalꤹ롣
#ifdef NO_SIGACTION
  signal (SIGALRM,writeAudioData);
#else
  sigaction (SIGALRM,&sigAction,NULL);
#endif//NO_SIGACTION
  itimerval itval;
  itval.it_value.tv_sec=itval.it_interval.tv_sec=
    intervalOfWritingAudioData.tv_sec;
  itval.it_value.tv_usec=itval.it_interval.tv_usec=
    intervalOfWritingAudioData.tv_usec;
  setitimer (ITIMER_REAL,&itval,NULL);
}

//audiodevicecloseǤƤӽФɬפͭ롣
void MaslAudio::offAudioTimer()
{
  //ŪˤsignalθƤӽФoffˤ
  itimerval itval;
  itval.it_interval.tv_sec=itval.it_interval.tv_usec=0;
  itval.it_value.tv_sec=itval.it_value.tv_usec=0;
  setitimer (ITIMER_REAL,&itval,NULL);
}

void MaslAudio::writeAudioData(int sig)
{//ºݤPCMmethod
  //ƤӽФ줿顢ݤƤbufferdatacopyAudio::play()롣
  //write()sizemin(fragment size,dataλĤsize)
  //fragmentsizeͤ꾮ͤwrite()Audio::post()
#ifdef NO_SIGACTION
  signal (sig,SIG_IGN);
#else
  //⤷ʤ
#endif//NO_SIGACTION

  //if ((!(*isAudioWriting))||sampleData.data==NULL)
  if (sampleData.data==NULL)
    {//writedata̵Τǡ⤻롣
      offAudioTimer ();
      return;
    }

  if (getNoBlockingSize ()<fragmentSize)
    {
#ifdef NO_SIGACTION
      signal (sig,writeAudioData);
#else
      sigaction (sig,&sigAction,NULL);
#endif //NO_SIGACTION
      return;//datawrite褦ȤblockΤǲ⤻롣
    }
  
  //cerr << "MaslAudio::writeAudioData () is called." << endl;
  
  if (fragmentSize<sampleData.size)
    {//writewrite٤dataĤäƤ롣
      Audio::play (sampleData.data,fragmentSize);
      sampleData.size-=fragmentSize;
      sampleData.data+=fragmentSize;
#ifdef NO_SIGACTION
      signal (sig,writeAudioData);
#else
      sigaction (sig,&sigAction,NULL);
#endif //NO_SIGACTION
      return;
    }
  else
    {//dataκǸޤwrite롣
      int tmpSize=0;
      if (queSampleData.data!=NULL)
	{//ԤäƤdataͭä
	  Audio::play (sampleData.data,sampleData.size);
	  tmpSize+=sampleData.size;
	  oldSampleData.data=sampleData.data=queSampleData.data;
	  oldSampleData.size=sampleData.size=queSampleData.size;
	  oldSampleData.isLoop=sampleData.isLoop=queSampleData.isLoop;
	  resetQueData ();
	}
      
      //ԤäƤdata̵(̵ʤäơdatarite
      if (sampleData.isLoop==False)
	{//loopʤ
	  //cerr << "last data ." << endl;
	  if (fragmentSize-tmpSize<sampleData.size)
	    {//dataޤǤ񤭹ʤ
	      Audio::play (sampleData.data,fragmentSize-tmpSize);
	      sampleData.data+=fragmentSize-tmpSize;
	      sampleData.size-=fragmentSize-tmpSize;
#ifdef NO_SIGACTION
	      signal (sig,writeAudioData);
#else
	      sigaction (sig,&sigAction,NULL);
#endif //NO_SIGACTION
	      return;
	    }
	  else
	    {//dataκǸޤǽ񤭹
	      offAudioTimer ();
	      Audio::play (sampleData.data,sampleData.size);
#ifdef OPEN_SOUND_SYSTEM
	      tmpSize+=sampleData.size;
	      Audio::play (nullSound,fragmentSize-tmpSize);
#endif//OPEN_SOUND_SYSTEM
	      //Audio::post ()
	      //Audio::post ();
	      if (*isAudioWaiting)Audio::sync ();

	      oldSampleData.data=sampleData.data=NULL;
	      oldSampleData.size=sampleData.size=-1;
	      oldSampleData.isLoop=sampleData.isLoop=False;
	      *isAudioWriting=0;
	      return;
	    }
	}
      else
	{//loop
	  while (tmpSize<fragmentSize)
	    {//fragmentsizeäѤޤwrite
	      if (sampleData.size<fragmentSize-tmpSize)
		{//sampleDatawrite
		  Audio::play (sampleData.data,sampleData.size);
		  //sampleDataκǸޤǤädataƬ
		  tmpSize+=sampleData.size;
		  sampleData.data=oldSampleData.data;
		  sampleData.size=oldSampleData.size;
		}
	      else
		{//sampleDataޤǤwriteʤ
		 //ǽ
		  Audio::play (sampleData.data,fragmentSize-tmpSize);
		  sampleData.size-=fragmentSize-tmpSize;
		  sampleData.data+=fragmentSize-tmpSize;
		  break;
		}
	    }
#ifdef NO_SIGACTION
	  signal (sig,writeAudioData);
#else
	  sigaction (sig,&sigAction,NULL);
#endif //NO_SIGACTION
	  return;
	}
    }
  //writedata̵isAudioWriting=Falseˤ
  //timeroffˤ롣isAudioWaiting=TrueʤisAudioWaiting=Falseˤ롣
}

//Audio::setsamplerate()ƤӽФƤʪϼ֤롣
Bool MaslAudio::setSampleRate(const long rate)
{
  offAudioTimer ();
  resetAudioVariable ();
  resetQueData ();
  
  int sampleRate=rate;
  Bool tmp=Audio::setRate (sampleRate);
  if (tmp)
    {//rate
      prepareMaslAudio (isAudioWriting,isAudioWaiting);
      return True;
    }
  else
    {
      return False;//rate˼Ԥ
    }
}


void MaslAudio::stopAudio (const int channel)
{
  ///////////////////////////////////ϼ괺Ǥ
  int sampleRate=Audio::getSampleRate ();
  Audio::resetAudioDevice ();
  Audio::initializeAudioDevice (sampleRate);
  resetAudioVariable ();
  resetQueData ();
}

//Audio::reset()ƤӽФƤϼ֤
void MaslAudio::resetAudio()
{//ߤ롣ΤˤϺʪλ
  offAudioTimer ();
  stopAudio (0xff);
/*
  Audio::resetAudioDevice();
  resetAudioVariable();
*/
}

void MaslAudio::resetAudioVariable()
{
  //ѿν
  oldSampleData.data=sampleData.data=NULL;
  oldSampleData.size=sampleData.size=-1;
  oldSampleData.isLoop=sampleData.isLoop=False;
  *isAudioWriting=0;
  *isAudioWaiting=0;
}

//////////////////////////////////////////////////Queط
void MaslAudio::queAudioData (const SAMPLE_DATA pcmData,const int channel=-1)
{
  queSampleData.data=pcmData.data;
  queSampleData.size=pcmData.size;
  queSampleData.isLoop=pcmData.isLoop;
  queChannel=channel;
}

void MaslAudio::resetQueData ()
{
  queSampleData.data=NULL;
  queSampleData.size=-1;
  queSampleData.isLoop=False;
  queChannel=-1;
}
