/* 
        pknmake.cc

        MASL/M-MASL Copyright (c) KUNI/TDU$B1~>p8&(B
        Windows version Copyright (c) 1995, 1996 Tomoatsu Shimada  (shimarin)
        X Window System version Copyright (c)1997 Yamahata Isaku (ISA-9)
*/
#include <iostream.h>
#include <string.h>
#include <stdlib.h>

#include "MaslInputStream.h"
#include "MaslOutputStream.h"
#include "printError.h"

static void writeHeader (MaslOutputStream& pkn,MaslInputStream& pcm,
			 const char* const pknFileName);
static void addPcm (MaslOutputStream& pkn,MaslInputStream& pcm,
		    const char* const pknFileName,
		    const unsigned char type,const char* const pcmFileName);

main (int argc,char** argv)
{
  if (argc<2)
    {
      cerr << "Usage:" << argv[0] << " .pkn .[pc8|pcm]" << endl;
      exit (-1);
    }

  ///////////////////////////////////////////$B3HD%;R$N%A%'%C%/(B
  unsigned char type=0;
  char* const pknFileName=argv[1];
  char* const pcmFileName=argv[2];

  const int offset=strlen (pcmFileName)-4;//$B3HD%;R$r;X$9(B(=.pc3|.pcm)
  if ((*(pcmFileName+offset  )=='.' &&
       *(pcmFileName+offset+1)=='p' &&
       *(pcmFileName+offset+2)=='c' &&
       *(pcmFileName+offset+3)=='8') ||
      (*(pcmFileName+offset  )=='.' &&
       *(pcmFileName+offset+1)=='P' &&
       *(pcmFileName+offset+2)=='C' &&
       *(pcmFileName+offset+3)=='8'))
    {
      type=0;
    }
  else if ((*(pcmFileName+offset  )=='.' &&
	    *(pcmFileName+offset+1)=='p' &&
	    *(pcmFileName+offset+2)=='c' &&
	    *(pcmFileName+offset+3)=='m') ||
	   (*(pcmFileName+offset  )=='.' &&
	    *(pcmFileName+offset+1)=='P' &&
	    *(pcmFileName+offset+2)=='C' &&
	    *(pcmFileName+offset+3)=='M'))
    {
      type=1;
      cerr << pcmFileName << " is not pcm data." << endl;
      cerr << ".pcm is not supported." << endl;
      //exit (-1);
    }
  
  
  ////////////////////////////////////////////open files
  MaslOutputStream pkn (pknFileName,ios::out|ios::app);
  if (!pkn)
    {
      printErrorCanNotOpen (pknFileName);
      pkn.close ();
      exit (-1);
    }
  
  MaslInputStream pcm (pcmFileName,ios::in|ios::nocreate);
  if (!pcm)
    {
      printErrorCanNotOpen (pcmFileName);
      pcm.close ();
      pkn.close ();
      exit (-1);
    }
  
  cout << "now appending " << pcmFileName << " to " << pknFileName << "..."
       << endl;
  ////////////////////////////////////////header$B=q$-=P$7(B
  if (pkn.tellp ()==0)
    {//magic number$B5Z$S(Bfile name$B$r=q$/(B
      writeHeader (pkn,pcm,pknFileName);
    }
  
  //////////////////////////////////////pcm data$B$rIU$12C$($k(B
  addPcm (pkn,pcm,pknFileName,type,pcmFileName);

  /////////////////////////////////////$B=*$j(B
  pcm.close ();
  pkn.close ();
  cout << "done" << endl;
}

static void writeHeader (MaslOutputStream& pkn,MaslInputStream& pcm,
			 const char* const pknFileName)
{//magic number$B5Z$S(Bfile name$B$r=q$/(B
  char PKN[8]="PKN";
  memset (PKN+3,0,5);
  pkn.write (PKN,8);
  char autherName[32];
  memset (autherName,0,32);
  const char* const progName="pknmake.cc:";
  strcpy (autherName,progName);
  strncat (autherName,getenv ("LOGNAME"),32-strlen (progName)-1);
  pkn.write (autherName,32);
  if (pkn.fail ())
    {
      printErrorCanNotWrite (pknFileName);
      pkn.close ();
      pcm.close ();
      exit (-1);
    }
}


static void addPcm (MaslOutputStream& pkn,MaslInputStream& pcm,
		    const char* const pknFileName,
		    const unsigned char type,const char* const pcmFileName)
{
  pkn.write (&type,1);
  char fileName[16];
  memset (fileName,0,16);
  strncpy (fileName,pcmFileName,16);
  pkn.write (fileName,16);
  cout << "input sample rate of " << pcmFileName << ":";
  int sampleRate=0;
  cin >> sampleRate;
  pkn.put16 (sampleRate);
  long now=pcm.tellg ();
  pcm.seekg (0,ios::end);
  const long pcmSize=pcm.tellg ()-now;
  pcm.seekg (now,ios::beg);
  pkn.put32 (pcmSize);
  char* const data=new char[pcmSize];
  pcm.read (data,pcmSize);
  pkn.write (data,pcmSize);
  if (pkn.fail ())
    {
      printErrorCanNotWrite (pknFileName);
      pkn.close ();
      pcm.close ();
      exit (-1);
    }

  delete[] data;
}
